# Copyright 2016  Lars Wirzenius
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# =*= License: GPL-3+ =*=


import email
import time


class MessageThread(object):

    def __init__(self):
        self._messages = []

    def add_message(self, msg):
        self._messages.append(msg)

    def get_messages_in_date_order(self):
        return sorted(self._messages, key=self._get_timestamp)

    def _get_timestamp(self, msg):
        date_value = msg['Date']
        tm = email.utils.parsedate(date_value)
        if tm is None:  # pragma: no cover
            return 0
        return time.mktime(tm)
