# Copyright 2014  Lars Wirzenius
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# =*= License: GPL-3+ =*=


class Metadata(object):

    def __init__(self):
        self._data = {}

    def keys(self):
        return self._data.keys()

    def add(self, key, value):
        self._data[key] = self._data.get(key, []) + [value]

    def get_all_values(self, key):
        return self._data[key]

    def get_first_value(self, key, default=None):
        if key in self._data:
            return self._data[key][0]
        return default

    def remove(self, key, value):
        self._data[key].remove(value)
        if not self._data[key]:
            del self._data[key]

    def remove_all_values(self, key):
        del self._data[key]

    def __contains__(self, key):
        return key in self._data
